const get_acl_native = require('./build/Release/get_acl_native');
const set_acl_native = require('./build/Release/set_acl_native');

function filterAcesToIgnore(acl, acesToIgnore) {
    const filteredAcesArray = acl.split('\n').filter(ace => {
        const reducer = (accumulator, aceToIgnore) => accumulator && !ace.startsWith(aceToIgnore);
        return acesToIgnore.reduce(reducer, true);
    });
    return filteredAcesArray.join('\n');
}

function get(path, acesToIgnore) {
    const acl = get_acl_native.get(path);
    if (acesToIgnore.length === 0)
        return acl;
    else
        return filterAcesToIgnore(acl, acesToIgnore);
}

function set(path, acl, isDir) {
    set_acl_native.set(path, acl, isDir);
}

module.exports = {get, set};
